Fix thinko in previous patch
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils time
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet gawk"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet time
87 bash"
88
89 # directories to be built in a cross environment only
90 #
91 cross_only="target-libiberty target-libgloss target-newlib"
92
93 ## All tools belong in one of the four categories, and are assigned above
94 ## We assign ${configdirs} this way to remove all embedded newlines. This
95 ## is important because configure will choke if they ever get through.
96 ## ${configdirs} is directories we build using the host tools.
97 ## ${target_configdirs} is directories we build using the target tools.
98 #
99 configdirs=`echo ${host_libs} ${host_tools}`
100 target_configdirs=`echo ${target_libs} ${target_tools}`
101
102 ################################################################################
103
104 srctrigger=move-if-change
105 srcname="gnu development package"
106
107 # This gets set non-empty for some net releases of packages.
108 appdirs=""
109
110 # per-host:
111
112 # Work in distributions that contain no compiler tools, like Autoconf.
113 if [ -d ${srcdir}/config ]; then
114 case "${host}" in
115 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
116 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
117 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
118 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
119 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
120 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
121 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
122 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
123 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
124 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
125 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
126 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
127 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
128 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
130 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
131 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
132 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
133 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
134 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
135 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
136 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
137 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
138 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
139 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
140 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
141 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
142 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
143 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
144 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
145 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
146 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
147 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
148 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
149 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
150 esac
151 fi
152
153 # If we aren't going to be using gcc, see if we can extract a definition
154 # of CC from the fragment.
155 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
156 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
157 found=
158 for dir in $PATH; do
159 test -z "$dir" && dir=.
160 if test -f $dir/gcc; then
161 found=yes
162 break
163 fi
164 done
165 IFS="$save_ifs"
166 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
167 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
168 if [ -n "${xx}" ] ; then
169 CC=$xx
170 fi
171 fi
172 fi
173
174 # We default to --with-shared on platforms where -fpic is meaningless.
175 # Well, we don't yet, but we will.
176 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
177 case "${target}" in
178 alpha-dec-osf*) enable_shared=yes ;;
179 alpha-*-linux*) enable_shared=yes ;;
180 mips-sgi-irix5*) enable_shared=yes ;;
181 *) enable_shared=no ;;
182 esac
183 fi
184
185 case "${enable_shared}" in
186 yes) shared=yes ;;
187 no) shared=no ;;
188 "") shared=no ;;
189 *) shared=yes ;;
190 esac
191
192 if [ x${shared} = xyes ]; then
193 waugh=
194 case "${host}" in
195 hppa*) waugh=config/mh-papic ;;
196 i[345]86-*) waugh=config/mh-x86pic ;;
197 sparc64-*) waugh=config/mh-sparcpic ;;
198 *) waugh=config/mh-${host_cpu}pic ;;
199 esac
200 if [ -f ${srcdir}/${waugh} ]; then
201 if [ -n "${host_makefile_frag}" ] ; then
202 cat ${srcdir}/${host_makefile_frag} > mh-frag
203 cat ${srcdir}/${waugh} >> mh-frag
204 host_makefile_frag=mh-frag
205 else
206 host_makefile_frag=${waugh}
207 fi
208 fi
209 fi
210
211 # per-target:
212
213 case "${target}" in
214 v810*) target_makefile_frag=config/mt-v810 ;;
215 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
216 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
217 esac
218
219 skipdirs=
220 gasdir=gas
221 use_gnu_ld=
222 use_gnu_as=
223
224 # some tools are so dependent upon X11 that if we're not building with X,
225 # it's not even worth trying to configure, much less build, that tool.
226
227 case ${with_x} in
228 yes | "") # the default value for this tree is that X11 is available
229 ;;
230 no)
231 skipdirs="${skipdirs} tk gash"
232 ;;
233 *)
234 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
235 ;;
236 esac
237
238 # Some tools are only suitable for building in a "native" situation.
239 # Those are added when we have a host==target configuration. For cross
240 # toolchains, we add some directories that should only be useful in a
241 # cross-compiler.
242
243 is_cross_compiler=
244
245 if [ x"${host}" = x"${target}" ] ; then
246 # when doing a native toolchain, don't build the targets
247 # that are in the 'cross only' list
248 skipdirs="${skipdirs} ${cross_only}"
249 is_cross_compiler=no
250 target_subdir=.
251 else
252 # similarly, don't build the targets in the 'native only'
253 # list when building a cross compiler
254 skipdirs="${skipdirs} ${native_only}"
255 is_cross_compiler=yes
256 target_subdir=${target_alias}
257 if [ ! -d ${target_subdir} ] ; then
258 if mkdir ${target_subdir} ; then true
259 else
260 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
261 exit 1
262 fi
263 fi
264 fi
265
266 copy_dirs=
267
268 # Handle --with-headers=XXX. The contents of the named directory are
269 # copied to $(tooldir)/sys-include.
270 if [ x"${with_headers}" != x ]; then
271 if [ x${is_cross_compiler} = xno ]; then
272 echo 1>&2 '***' --with-headers is only supported when cross compiling
273 exit 1
274 fi
275 case "${exec_prefixoption}" in
276 "") x=${prefix} ;;
277 *) x=${exec_prefix} ;;
278 esac
279 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
280 fi
281
282 # Handle --with-libs=XXX. Multiple directories are permitted. The
283 # contents are copied to $(tooldir)/lib.
284 if [ x"${with_libs}" != x ]; then
285 if [ x${is_cross_compiler} = xno ]; then
286 echo 1>&2 '***' --with-libs is only supported when cross compiling
287 exit 1
288 fi
289 # Copy the libraries in reverse order, so that files in the first named
290 # library override files in subsequent libraries.
291 case "${exec_prefixoption}" in
292 "") x=${prefix} ;;
293 *) x=${exec_prefix} ;;
294 esac
295 for l in ${with_libs}; do
296 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
297 done
298 fi
299
300 # If both --with-headers and --with-libs are specified, default to
301 # --without-newlib.
302 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
303 if [ x"${with_newlib}" = x ]; then
304 with_newlib=no
305 fi
306 fi
307
308 # Recognize --with-newlib/--without-newlib.
309 if [ x${with_newlib} = xno ]; then
310 skipdirs="${skipdirs} target-newlib"
311 elif [ x${with_newlib} = xyes ]; then
312 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
313 fi
314
315 # Default to using --with-stabs for certain targets.
316 if [ x${with_stabs} = x ]; then
317 case "${target}" in
318 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
319 with_stabs=yes;
320 withoptions="${withoptions} --with-stabs"
321 ;;
322 esac
323 fi
324
325 # Handle ${copy_dirs}
326 set fnord ${copy_dirs}
327 shift
328 while [ $# != 0 ]; do
329 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
330 :
331 else
332 echo Copying $1 to $2
333
334 # Use the install script to create the directory and all required
335 # parent directories.
336 if [ -d $2 ]; then
337 :
338 else
339 echo >config.temp
340 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
341 fi
342
343 # Copy the directory, assuming we have tar.
344 # FIXME: Should we use B in the second tar? Not all systems support it.
345 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
346
347 # It is the responsibility of the user to correctly adjust all
348 # symlinks. If somebody can figure out how to handle them correctly
349 # here, feel free to add the code.
350
351 echo $1 > $2/COPIED
352 fi
353 shift; shift
354 done
355
356 # Configure extra directories which are host specific
357
358 case "${host}" in
359 i[345]86-*-go32*)
360 configdirs="$configdirs dosrel" ;;
361 *-cygwin32*)
362 configdirs="$configdirs dosrel" ;;
363 esac
364
365 # Remove more programs from consideration, based on the host or
366 # target this usually means that a port of the program doesn't
367 # exist yet.
368
369 noconfigdirs=""
370
371 case "${host}" in
372 i[345]86-*-vsta)
373 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 i[345]86-*-go32)
376 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 *-*-cygwin32)
379 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
380 ;;
381 ppc*-*-pe)
382 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
383 ;;
384 esac
385
386
387 case "${target}" in
388 *-*-netware)
389 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
390 ;;
391 *-*-vxworks*)
392 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
393 ;;
394 *-*-ose)
395 noconfigdirs="$noconfigdirs target-libgloss"
396 ;;
397 alpha-dec-osf*)
398 # ld works, but does not support shared libraries. emacs doesn't
399 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
400 # gas doesn't generate exception information.
401 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
402 ;;
403 alpha*-*-*vms*)
404 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
405 ;;
406 alpha*-*-*)
407 # newlib is not 64 bit ready
408 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
409 ;;
410 # start-sanitize-arc
411 arc-*-*)
412 noconfigdirs="$noconfigdirs target-libgloss"
413 ;;
414 # end-sanitize-arc
415 arm-*-pe*)
416 noconfigdirs="$noconfigdirs target-libgloss"
417 ;;
418 arm-*-riscix*)
419 noconfigdirs="$noconfigdirs ld target-libgloss"
420 ;;
421 h8300*-*-* | \
422 h8500-*-*)
423 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
424 ;;
425 hppa*-*-*elf* | \
426 hppa*-*-lites*)
427 # Do configure ld/binutils/gas for this case.
428 ;;
429 hppa*-*-*)
430 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
431 # cc is gcc, and on any system a user should be able to link cc to
432 # whatever they want. FIXME, emacs emacs19).
433 case "${CC}" in
434 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
435 *) ;;
436 esac
437 noconfigdirs="$noconfigdirs ld shellutils"
438 ;;
439 i[345]86-*-go32)
440 # but don't build gdb
441 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
442 ;;
443 *-*-cygwin32)
444 target_configdirs="$target_configdirs target-winsup"
445 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
446 # always build newlib.
447 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
448
449 # Can't build gdb for cygwin32 if not native.
450 case "${host}" in
451 *-*-cygwin32) ;; # keep gdb
452 *) noconfigdirs="$noconfigdirs gdb"
453 esac
454 ;;
455 i[345]86-*-pe)
456 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
457 ;;
458 i[345]86-*-sco3.2v5*)
459 # The linker does not yet know about weak symbols in COFF,
460 # and is not configured to handle mixed ELF and COFF.
461 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
462 ;;
463 i[345]86-*-sco*)
464 noconfigdirs="$noconfigdirs gprof target-libgloss"
465 ;;
466 i[345]86-*-solaris2*)
467 # The linker does static linking correctly, but the Solaris C library
468 # has bugs such that some important functions won't work when statically
469 # linked. (See man pages for getpwuid, for example.)
470 noconfigdirs="$noconfigdirs ld target-libgloss"
471 ;;
472 i[345]86-*-sysv4*)
473 # The SYSV4 C compiler doesn't handle Emacs correctly
474 case "${CC}" in
475 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
476 *) ;;
477 esac
478 # but that's okay since emacs doesn't work anyway
479 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
480 ;;
481 powerpc-*-aix*)
482 # copied from rs6000-*-* entry
483 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
484 # This is needed until gcc and ld are fixed to work together.
485 use_gnu_ld=no
486 ;;
487 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
488 target_configdirs="$target_configdirs target-winsup"
489 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
490 # always build newlib.
491 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
492 ;;
493 # This is temporary until we can link against shared libraries
494 powerpcle-*-solaris*)
495 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
496 ;;
497 rs6000-*-lynxos*)
498 # The CVS server code doesn't work on the RS/6000
499 # Newlib makes problems for libg++ in crosses.
500 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
501 ;;
502 rs6000-*-aix*)
503 noconfigdirs="$noconfigdirs gprof"
504 # This is needed until gcc and ld are fixed to work together.
505 use_gnu_ld=no
506 ;;
507 rs6000-*-*)
508 noconfigdirs="$noconfigdirs gprof"
509 ;;
510 m68k-apollo-*)
511 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
512 ;;
513 mips*-*-irix5*)
514 # The GNU linker does not support shared libraries.
515 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
516 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
517 ;;
518 mips*-*-irix6*)
519 # The GNU linker does not support shared libraries.
520 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
521 # BFD does not have Irix 6 support yet.
522 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
523 ;;
524 mips*-dec-bsd*)
525 noconfigdirs="$noconfigdirs gprof target-libgloss"
526 ;;
527 mips*-*-bsd*)
528 noconfigdirs="$noconfigdirs gprof target-libgloss"
529 ;;
530 mips*-*-*)
531 noconfigdirs="$noconfigdirs gprof"
532 ;;
533 romp-*-*)
534 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
535 ;;
536 sh-*-*)
537 case "${host}" in
538 i[345]86-*-vsta) ;; # don't add gprof back in
539 i[345]86-*-go32) ;; # don't add gprof back in
540 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
541 esac
542 noconfigdirs="$noconfigdirs target-libgloss"
543 ;;
544 sparc-*-sunos4*)
545 if [ x${is_cross_compiler} != xno ] ; then
546 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
547 else
548 use_gnu_ld=no
549 fi
550 ;;
551 v810-*-*)
552 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
553 ;;
554 vax-*-vms)
555 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
556 ;;
557 vax-*-*)
558 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
559 ;;
560 *-*-lynxos*)
561 # Newlib makes problems for libg++ in crosses.
562 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
563 ;;
564 *-*-macos* | \
565 *-*-mpw*)
566 # Macs want a resource compiler.
567 configdirs="$configdirs grez"
568 ;;
569 esac
570
571 # targets that need a second pass
572 case "${target}" in
573 *-gm-magic*)
574 noconfigdirs="$noconfigdirs target-libgloss"
575 ;;
576 esac
577
578 # If we aren't building newlib, then don't build libgloss, since libgloss
579 # depends upon some newlib header files.
580 case "${noconfigdirs}" in
581 *target-libgloss*) ;;
582 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
583 esac
584
585 # If we are building a Canadian Cross, discard tools that can not be built
586 # using a cross compiler. FIXME: These tools should be fixed.
587 if [ "${build}" != "${host}" ]; then
588 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
589 fi
590
591 # Make sure we don't let GNU ld be added if we didn't want it.
592 if [ x$with_gnu_ld = xno ]; then
593 use_gnu_ld=no
594 noconfigdirs="$noconfigdirs ld"
595 fi
596
597 # Make sure we don't let GNU as be added if we didn't want it.
598 if [ x$with_gnu_as = xno ]; then
599 use_gnu_as=no
600 noconfigdirs="$noconfigdirs gas"
601 fi
602
603 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
604 # $target_configdirs.
605 # If we have the source for $noconfigdirs entries, add them to $notsupp.
606
607 notsupp=""
608 for dir in . $skipdirs $noconfigdirs ; do
609 dirname=`echo $dir | sed -e s/target-//g`
610 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
611 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
612 if [ -r $srcdir/$dirname/configure ] \
613 || [ -r $srcdir/$dirname/configure.in ]; then
614 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
615 true
616 else
617 notsupp="$notsupp $dir"
618 fi
619 fi
620 fi
621 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
622 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
623 if [ -r $srcdir/$dirname/configure ] \
624 || [ -r $srcdir/$dirname/configure.in ]; then
625 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
626 true
627 else
628 notsupp="$notsupp $dir"
629 fi
630 fi
631 fi
632 done
633
634 # Sometimes the tools are distributed with libiberty but with no other
635 # libraries. In that case, we don't want to build target-libiberty.
636 if [ -n "${target_configdirs}" ]; then
637 others=
638 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
639 if [ "$i" != "libiberty" ]; then
640 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
641 others=yes;
642 break;
643 fi
644 fi
645 done
646 if [ -z "${others}" ]; then
647 target_configdirs=
648 fi
649 fi
650
651 # Deconfigure all subdirectories, in case we are changing the
652 # configuration from one where a subdirectory is supported to one where it
653 # is not.
654 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
655 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
656 rm -f $i/Makefile
657 done
658 fi
659 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
660 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
661 rm -f ${target_subdir}/$i/Makefile
662 done
663 fi
664
665 # Produce a warning message for the subdirs we can't configure.
666 # This isn't especially interesting in the Cygnus tree, but in the individual
667 # FSF releases, it's important to let people know when their machine isn't
668 # supported by the one or two programs in a package.
669
670 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
671 # If $appdirs is non-empty, at least one of those directories must still
672 # be configured, or we error out. (E.g., if the gas release supports a
673 # specified target in some subdirs but not the gas subdir, we shouldn't
674 # pretend that all is well.)
675 if [ -n "$appdirs" ]; then
676 for dir in $appdirs ; do
677 if [ -r $dir/Makefile.in ]; then
678 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
679 appdirs=""
680 break
681 fi
682 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
683 appdirs=""
684 break
685 fi
686 fi
687 done
688 if [ -n "$appdirs" ]; then
689 echo "*** This configuration is not supported by this package." 1>&2
690 exit 1
691 fi
692 fi
693 # Okay, some application will build, or we don't care to check. Still
694 # notify of subdirs not getting built.
695 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
696 echo " ${notsupp}" 1>&2
697 echo " (Any other directories should still work fine.)" 1>&2
698 fi
699
700 # Set with_gnu_as and with_gnu_ld as appropriate.
701 #
702 # This is done by determining whether or not the appropriate directory
703 # is available, and by checking whether or not specific configurations
704 # have requested that this magic not happen.
705 #
706 # The command line options always override the explicit settings in
707 # configure.in, and the settings in configure.in override this magic.
708 #
709 # If the default for a toolchain is to use GNU as and ld, and you don't
710 # want to do that, then you should use the --without-gnu-as and
711 # --without-gnu-ld options for the configure script.
712
713 if [ x${use_gnu_as} = x ] ; then
714 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
715 with_gnu_as=yes
716 withoptions="$withoptions --with-gnu-as"
717 fi
718 fi
719
720 if [ x${use_gnu_ld} = x ] ; then
721 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
722 with_gnu_ld=yes
723 withoptions="$withoptions --with-gnu-ld"
724 fi
725 fi
726
727 if [ x${shared} = xyes ]; then
728 case "${target}" in
729 hppa*) target_makefile_frag=config/mt-papic ;;
730 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
731 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
732 esac
733 fi
734
735 # post-target:
736
737 # Make sure that the compiler is able to generate an executable. If it
738 # can't, we are probably in trouble. We don't care whether we can run the
739 # executable--we might be using a cross compiler--we only care whether it
740 # can be created. At this point the main configure script has set CC.
741 echo "int main () { return 0; }" > conftest.c
742 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
743 if [ $? = 0 ] && [ -s conftest ]; then
744 :
745 else
746 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
747 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
748 rm -f conftest*
749 exit 1
750 fi
751 rm -f conftest*
752
753 # The Solaris /usr/ucb/cc compiler does not appear to work.
754 case "${host}" in
755 sparc-sun-solaris2*)
756 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
757 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
758 could_use=
759 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
760 if [ -d /opt/cygnus/bin ] ; then
761 if [ "$could_use" = "" ] ; then
762 could_use="/opt/cygnus/bin"
763 else
764 could_use="$could_use or /opt/cygnus/bin"
765 fi
766 fi
767 if [ "$could_use" = "" ] ; then
768 echo "Warning: compilation may fail because you're using"
769 echo "/usr/ucb/cc. You should change your PATH or CC "
770 echo "variable and rerun configure."
771 else
772 echo "Warning: compilation may fail because you're using"
773 echo "/usr/ucb/cc, when you should use the C compiler from"
774 echo "$could_use. You should change your"
775 echo "PATH or CC variable and rerun configure."
776 fi
777 fi
778 ;;
779 esac
780
781 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
782 # binutils tools will find libbfd.so.
783 if [ "${shared}" = "yes" ]; then
784 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
785 Makefile > Makefile.tem
786 rm -f Makefile
787 mv -f Makefile.tem Makefile
788
789 case "${host}" in
790 *-*-hpux*)
791 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
792 Makefile > Makefile.tem
793 rm -f Makefile
794 mv -f Makefile.tem Makefile
795 ;;
796 esac
797 fi
798
799 # Record target_configdirs and the configure arguments in Makefile.
800 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
801 targargs=`echo "${arguments}" | \
802 sed -e 's/--norecursion//' \
803 -e 's/--cache[a-z-]*=[^ ]*//' \
804 -e 's/--ho[a-z-]*=[^ ]*//' \
805 -e 's/--ta[a-z-]*=[^ ]*//'`
806
807 # Passing a --with-cross-host argument lets the target libraries know
808 # whether they are being built with a cross-compiler or being built
809 # native. However, it would be better to use other mechanisms to make the
810 # sorts of decisions they want to make on this basis. Please consider
811 # this option to be deprecated. FIXME.
812 if [ x${is_cross_compiler} = xyes ]; then
813 targargs="--with-cross-host=${host_alias} ${targargs}"
814 fi
815
816 targargs="--host=${target_alias} ${targargs}"
817 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
818 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
819 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
820 Makefile > Makefile.tem
821 rm -f Makefile
822 mv -f Makefile.tem Makefile
823
824 #
825 # Local Variables:
826 # fill-column: 131
827 # End:
828 #
This page took 0.061944 seconds and 4 git commands to generate.